#include <iostream>

template<typename T, typename U>
std::common_type_t<T, U> add(const T& lhs, const U& rhs) {
    return lhs + rhs;
}

auto foo(auto lhs, auto rhs) {
    return add<decltype(lhs), decltype(rhs)>(lhs, rhs);
}

// specialization of above (generated by compiler)
template<>
auto foo<float, int>(float lhs, int rhs) {
    return add<float, int>(lhs, rhs);
}

int main() {
    std::cout << foo(3.14, 2) << std::endl;    

    return 0;
}
